<?php

class PerchForms_Forms extends PerchAPI_Factory
{
    protected $singular_classname = 'PerchForms_Form';
    protected $table    = 'forms';
    protected $pk   = 'formID';

    public function find_by_key($key)
    {
        $sql = 'SELECT * 
                FROM '.$this->table.'
                WHERE formKey='.$this->db->pdb($key).'
                LIMIT 1';
        $row = $this->db->get_row($sql);
        
        return $this->return_instance($row);
    }


    /**
     * Get an array of templates in the content folder.
     *
     * @param string $path 
     * @return void
     * @author Drew McLellan
     */
    public function get_templates($path=false, $include_hidden=false, $initial_path=false)
    {
        $Perch = Perch::fetch();
        
        if ($path===false) $path = PERCH_TEMPLATE_PATH.'/forms/emails';
        if ($initial_path===false) $initial_path = $path;
        $a = array();
        $groups = array();
        $p = false;
        if (is_dir($path)) {
            if ($dh = opendir($path)) {
                while (($file = readdir($dh)) !== false) {
                    if(substr($file, 0, 1) != '.' && ($include_hidden || substr($file, 0, 1) != '_') && !preg_match($Perch->ignore_pattern, $file)) {
                        $extension = PerchUtil::file_extension($file);
                        if ($extension == 'html' || $extension == 'htm') {
                            $p = str_replace($initial_path, '', $path);
                            if (!$p) {
                                $a[PerchLang::get('Templates')][] = array('filename'=>$file, 'value'=>$file, 'path'=>$file, 'label'=>$this->template_display_name($file));
                            }else{
                                $a[] = array('filename'=>$file, 'value'=>ltrim($p, '/').'/'.$file, 'path'=>ltrim($p, '/').'/'.$file, 'label'=>$this->template_display_name($file));
                            }
                        }else{
                            // Use this one of infinite recursive nesting. Group stuff below normalised for HTML select optgroups that only do one level
                            //$a[$this->template_display_name($file)] = $this->get_templates($path.'/'.$file, $include_hidden, $initial_path);
                            
                            if ($p) {
                                $group_name = $this->template_display_name(trim($p, '/\\').'/'.$file);
                            }else{
                                $group_name = $this->template_display_name($file);
                            }
                            
                            $groups[$group_name] = $this->get_templates($path.'/'.$file, $include_hidden, $initial_path);
                        }
                    }
                }
                closedir($dh);
            }
            if (PerchUtil::count($a)) $a = PerchUtil::array_sort($a, 'label');
        }
        return $a+$groups;
    }

    public function template_display_name($file_name)
    {
        if (substr($file_name, 0, 1) == '_') {
            $file_name = '*'.$file_name;
        }

        $file_name = str_replace('.html', '', $file_name);
        $file_name = str_replace('_', ' ', $file_name);
        $file_name = str_replace('-', ' - ', $file_name);
        $file_name = str_replace('/', ' / ', $file_name);
        
        $file_name = ucwords($file_name);
        
        return $file_name;
    }
}
